<?php
require("/home/spool/edugain-urn/Web/config.php");
require_once($realpath."/siLeDAP/LdapManager.php");
require_once($realpath."/siLeDAP/LdapConf.php");
require_once($realpath."/siLeDAP/xml2Array.php");
require_once('/home/spool/edugain-urn/simplesamlphp/www/_include.php');
require_once('SimpleSAML/Utilities.php');
require_once('SimpleSAML/Session.php');
require_once('SimpleSAML/XML/MetaDataStore.php');
require_once('SimpleSAML/XHTML/Template.php');

$URN_BASE="dc=urnreg,dc=edugain,dc=org";
$URN_PENDING='urn:mace:terena.org:schac:userStatus:edugain:registry:pending';

$MAIL_ADMIN="admin@domain.com";

$ID_ADMIN="user@domain.com";

$error='';

function getURNEntry($lm,$urnvalue) {
	GLOBAL $URN_BASE;

	$filter="(urnRegValue=".$urnvalue.")";
	error_log($filter);
	$entries=$lm->search($URN_BASE,$filter);
	if (count($entries)==1) {
		$urn=$entries[0];
		error_log("Got: ".$urn->getDN());
		return $urn;
	}
	return "";
}

function cancelUrn($lm,$urn) {
	GLOBAL $error;
	GLOBAL $MAIL_ADMIN;
	
	$entry=getURNEntry($lm,$urn);
	if (is_string($entry)) {
		$error="URN not found";
		return false;
	}
	
	$to = $entry->getSingleAttribute("mail");
	
	if ($lm->delEntry($entry->getDN(),false)) {
		$subject = "[URNreg eduGAIN] Request for registering the URN ".$urn;
		$text = "Hi,\nThe request has been denied This usually happens when the information associated to the URN is not right. If you need more information, you could reply this email asking for it.\nRegards\n";
		$headers = 'From: '.$MAIL_ADMIN. "\r\n" .
		'Reply-To: '.$MAIL_ADMIN. "\r\n" .
		'Bcc: '.$MAIL_ADMIN. "\r\n" .
		'X-Mailer: PHP/' . phpversion();
		mail($to,$subject,$text,$headers);
		$error="URN ".$urn." has been rejected";
		return true;
	}
	else {
		return false;
	}
}

function acceptUrn($lm,$urn) {
	GLOBAL $error;
	GLOBAL $MAIL_ADMIN;
	
	$entry=getURNEntry($lm,$urn);
	if (is_string($entry)) {
		$error="URN not found";
		return false;
	}
	
	$to = $entry->getSingleAttribute("mail");
	
	$attrs=array();
	$attrs['schacUserStatus']=array();
	
	if (ldap_modify($lm->getLdapLink(),$entry->getDN(),$attrs)) {
		$subject = "[URNreg eduGAIN] Request for registering the URN ".$urn;
		$text = "Hi,\nCongratulations! The request has been ACCEPTED.\nRegards\n";
		$headers = 'From: '.$MAIL_ADMIN. "\r\n" .
		'Reply-To: '.$MAIL_ADMIN. "\r\n" .
		'Bcc: '.$MAIL_ADMIN. "\r\n" .
		'X-Mailer: PHP/' . phpversion();
		mail($to,$subject,$text,$headers);
		$error="URN ".$urn." has been accepted";
		return true;
	}
	else {
		return false;
	}
}

session_start();

header('Content-type: text/xml');
echo "<Response>";

$config = SimpleSAML_Configuration::getInstance();
$metadata = new SimpleSAML_XML_MetaDataStore($config);

$session = SimpleSAML_Session::getInstance();

if (!isset($session) || !$session->isValid() ) {
	$success=false;
	$error="Not AuthN session available";
}
else {
	$attrs=$session->getAttributes();
	$ids=$attrs['urn:mace:dir:attribute-def:eduPersonTargetedId'];
	$id=$ids[0];
	if (strcmp($id,$ID_ADMIN)==0) {
		$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
		$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
		$lm->connectLdap($LDAP_USER,$LDAP_PASS);
		
		$success=false;
		
		if (array_key_exists('oper',$_REQUEST)) {
			$oper=$_REQUEST['oper'];
			if (strcmp($oper,"addurn")==0) { // Get an urn
				if (array_key_exists('action',$_REQUEST)&&array_key_exists('urn',$_REQUEST)) {
					$action=rawurldecode($_REQUEST['action']);
					$urn=rawurldecode($_REQUEST['urn']);
					if (strcmp($action,"cancel")==0) {
						$success=cancelUrn($lm,$urn);
					}
					else if (strcmp($action,"accept")==0) {
						$success=acceptUrn($lm,$urn);
					}
				}
			}
		}
	}
	else {
		$success=false;
		$error="You're not an admin";
	}
}
if ($success==true) {
    echo "<OperationInfo><Status status='success'/>";
    if (strcmp($error,"")!=0) {
    	echo "<InfoMessage message='".$error."'/>";
    }
    echo "</OperationInfo>";
}
else {
    echo "<OperationInfo><Status status='fail'/><ErrorMessage message='".$error."'/></OperationInfo>";
}
echo "</Response>";

?>
